; ***********************************************************************
;Gruppe:	OBJECT
;
;Autor:		Alex Stenz
;
;Datum		12.10.2004
;
; Funktion:     FlaechenStempelPLine
;
; Zweck:        schreibt die Flche einer gewhlten Polylinie in einen Attributsblock (siehe "FlaechenStempel.dwg")
;
; Argumente:	keine
;		
; Rckgabe:	ok sonst nil
;		
; Beispiel:	(FlaechenStempelPLine)
;
; **********************************************************************

(defun FlaechenStempelPLine ( / objChosenPLine objVLAInsert)
  
  (setq objChosenPLine (vlax-ename->vla-object (car (entsel))))
  
  (setq objVLAInsert
    (vla-InsertBlock (vla-get-modelspace (thisDrawing))
      (vlax-3d-point (getpoint "\nEinfgepunkt: "))
      (getfiled "FlaechenStempel auswaehlen" "c:\\temp\\" "dwg" 8) 1 1 1 0)
  )  
  (ChangeBlockAttributes objVLAInsert (list (append '("FLAECHENSTEMPEL") 
						    (list (strcat "%<\\AcObjProp.16.2 Object(%<\\_ObjId  "
								  (itoa (vlax-get objChosenPLine 'ObjectID))
								  ">%,1).Area>%")))))
  (command "_UPDATEFIELD" (entlast) "")
)



; ***********************************************************************
;Gruppe:	BLOCK
;
;Autor:		Alex Stenz
;
;Datum		12.10.2004
;
; Funktion:     ChangeBlockAttributes
;
; Zweck:        Ausfllen von gewnschten Attributen "Projektdaten.ini" im akt. Arbeitsverzeichniss
;		Wird ein Attribut im Block gefunden, wird dieser Attributname in der bergebenen Liste gesucht
;		==> wenn gefunden wird der Wert (aus Liste) gesetzt.
;
; Argumente:	VLA-OBJECT	Block dessen Attribs gendert werden sollen
;		LIST		Liste der Attribut-Tag's u. Attribut-Values die gendert werden sollen
;		
; Rckgabe:	ok sonst nil
;											TAG		VALUE
; Beispiel:	(ChangeBlockAttributes (vlax-ename->vla-object (car (entsel))) '(("AnwenderKurzzeichen" "254") ("Projekt1" "EINFAMILIENWOHNHAUS") ("Projekt2" "MIT GARAGE") ("BauherrVorname" "STENZ") ("BauherrNachVorname" "Alexander") ("BauherrStrasse" "Strasse des bauherrn") ("BauherrOrt" "Vorchdorf") ("Kastralgemeinde" "St Konrad") ("Parzellennummer" "000") ("Einlagezahl" "215") ("Plandatum" "11.10.2004")))
;
; ***********************************************************************

(defun ChangeBlockAttributes (objInsertToChange lstAttributesAndValues / )
  
  (if (and (= (vlax-get-property objInsertToChange 'ObjectName) "AcDbBlockReference")
           (= (vla-get-hasattributes objInsertToChange) :vlax-true))
    (progn
      (safearray-value (setq arrAtts (vlax-variant-value (vla-getattributes objInsertToChange))))
      
      (foreach objTag (vlax-safearray->list arrAtts) ;(vlax-dump-object objTag)
	(setq strTagString (vlax-get-property objTag 'TagString));(princ "\nstrTextString: ")(princ strTextString)
	(setq strTextString (vlax-get-property objTag 'TextString));(princ "\nstrTagString: ")(princ strTagString)
	(mapcar
	  '(lambda (strWishTag)
	     ;(princ (strcase strTagString))(princ " == ")(princ (strcase (nth 0 strWishTag)))(princ "\n")
	     (if (= (strcase strTagString) (strcase (nth 0 strWishTag))); BAUHERRVORNAME = BAUHERRVORNAME
	       (vlax-put-property objTag 'TextString (nth 1 strWishTag)); neuen Wert setzen
	     )
	   )
	  lstAttributesAndValues
	)
	objTag
      )
      'OK
    )
    nil
  )
)


  

